#lang errortrace racket
#|
(define (if c t e)
  (cond [c t] [else e]))

(define (div x y)
  (if (= y 0) 'error (/ x y)))

; (div 10 0)
(define (factorial x)
  (if (<= x 0) 1 (* x (factorial (- x 1)))))|#

;; (factorial 10)

(define (if b then-branch else-branch)
   (cond [b (then-branch)] [else (else-branch)]))

(define (factorial n)
  (if (= n 0) (lambda () (displayln "*") 1)
    (lambda ()
      (displayln n)
      (* n (factorial (- n 1))))))

;(factorial 10)

(define (thunk-repeat n th)
  (cond [(> n 0)
          (th)
          (thunk-repeat (- n 1) th)]))
;; (thunk-repeat 3
;;   (thunk (displayln "T") (sleep 1) "foo"))

(define (promise-repeat n th)
  (cond [(> n 0)
          (force th)
          (promise-repeat (- n 1) th)]))
;; (displayln "~~~~~~~~~~~")
;; (promise-repeat 3
;;   (delay (displayln "P") (sleep 1) "foo"))

(define p (delay (displayln "X") (sleep 1) "bar"))
#|
(displayln "~~~~~~~~~~~")
(thunk-repeat 3
  (thunk (force p)
         (force p)))
(force p)|#
;; (define (factorial x)
;;   (* x (factorial (- x 1))))
;;   (cond [(<= x 0) 1]
;;         [else (* x (factorial (- x 1)))]))

;(factorial 10)

(define (map f l)
  (cond [(empty? l) empty]
        [else
        (cons (f (first l)) (map f (rest l)))]))
#|
(define (powers-of-two)
  (define (powers-of-two-iter n)
    (cons n (thunk (powers-of-two-iter (* 2 n)))))
  (powers-of-two-iter 1))|#

(define (stream-get s) (car s))
(define (stream-next s) ((cdr s)))


#|


(powers-of-two)


(stream-get (powers-of-two))
(define 2.. (stream-next (powers-of-two)) )

2..

(stream-get 2..)
(define 4.. (stream-next 2..))

4..

(stream-next 4..)


4..
2..|#

(define stream-first stream-get)
(define stream-rest stream-next)

(define (count-until predicate s)
  (define (count-until-iter count s)
    (cond [(predicate (stream-first s))
           (count-until-iter (+ count 1) (stream-rest s))]
          [else count]))
  (count-until-iter 0 s))


(define (powers-of-two)
  (define (powers-of-two-iter n)
    (cons
      n
      (thunk (powers-of-two-iter (* n 2)))))
  (powers-of-two-iter 1))


;; (count-until (lambda (x) (<= x 10)) (powers-of-two))
;; (count-until (lambda (x) (= x 1)) (powers-of-two))
;(count-until (lambda (x) #t) (powers-of-two))

;; (check-equal? 3 (count-until (powers-of-two) (lambda (x) (< x 8))))
;; (check-equal? 0 (count-until (powers-of-two) (lambda (x) (<= x 0))))
;; (check-equal? 3 (count-until (powers-of-two) (curryr < 8)))  ; Reverse Currying
;; (check-equal? 0 (count-until (powers-of-two) (curryr <= 0))) ; Reverse Currying

(define (naturals)
  (define (naturals-iter n)
    (cons n (thunk (naturals-iter (+ n 1)))))
  (naturals-iter 0))
#|
(naturals)
(stream-first (naturals))
(stream-rest (naturals))|#

#|

(define (map f l)
  (cond [(empty? l) empty]
        [else (cons (f (first l)) (map f (rest l)))]))

|#

;(define (map:2 f l)
;  (foldr (lambda (element accum) (cons (f element) accum)) empty l))

;(map:2 (lambda (x) (+ x 2)) '(1 2 3))

(define (stream-map f l)
  (cons (f (stream-first l)) (thunk (stream-map f (stream-rest l)))))

(define (even-numbers) (stream-map (lambda (x) (* x 2)) (naturals)))

;; (even-numbers)
;; (stream-rest (even-numbers))
;; (stream-rest (stream-rest (even-numbers)))

;; (define n2 (stream-map (lambda (x) (+ x 2)) (naturals)))

;; n2
;;
;; (stream-first (stream-rest n2))
;;
;; (stream-rest (stream-rest n2))
(define (stream-zip s1 s2)
  (cons
    ; first-element
    (list (stream-first s1) (stream-first s2))
    ; rest of the stream
    (thunk (stream-zip (stream-rest s1) (stream-rest s2)))))


;; (stream-zip (naturals) (even-numbers))
;; (stream-rest (stream-zip (naturals) (even-numbers)))
;; (stream-rest (stream-rest (stream-zip (naturals) (even-numbers))))


(define (enumerate s)
  (stream-zip (naturals) s))


(enumerate (even-numbers))
(stream-rest (enumerate (even-numbers)))
(stream-rest (enumerate (even-numbers)))



